% main.m
clear all
close all
% Load training and testing set -> arcene
x = load('arcene_train.data');
y = load('arcene_train.labels');
y(y==-1)=2;

xt = load('arcene_valid.data');
yt = load('arcene_valid.labels');
yt(yt==-1)=2;

% Run BIC to select the size p
[n d]=size(x);
ML = signal_subspace_selection(x,y);
nbpc=ML;
 
% Train the SVM
[sig,C,alpha,b,V,fX]=do_hdda_rbf(x,y,nbpc);

% Predict 
temp = predict_hdda_rbf(xt,x,sig,alpha,b,V);
[~,yp] = max(temp,[],1);

oa = length(find(yp==yt'))/length(yt);