function ml = signal_subspace_selection(x,y)

d = size(x,2);

for CLASSE=1:max(y)
    if ~isempty(find(y==CLASSE))
        xi = x(y==CLASSE,:);
        ni = size(xi,1);
        co = double(cov(xi));
        if(ni<d)
            e = eigs(co,ni-1);
        else
            e = eigs(co,d-1);
        end
        D = min(ni,d)-1;
        if(~isempty(find(e<eps)))
            t=find(e<eps,1);
            D=t-1;
        end
        for p=1:D-1
            a = sum(e(1:p))/p;
            b = (trace(co)-p*a)/(D-p);
            ML(p)=p*log(a)+(D-p)*log(b);
        end
        [~, j]=min(ML);
        clear ML
        ml(CLASSE) = j;
    end
end

