function catell = signal_subspace_selection_catell(x,y,s)
d = size(x,2);
for CLASSE=1:max(y)
    if ~isempty(find(y==CLASSE)) %#ok<EFIND>
        % Select samples from class i
        xi = x(y==CLASSE,:);
        ni = size(xi,1);

        % Compute the covariance matrix
        co = double(cov(xi));
        
        % Compute the eigenvectors/engeivalues
        if(ni-1>d)
            [v e]=eig(co);
        else
            [v e]=eigs(co,ni-1);
        end
        e = diag(e);
        [e,i]=sort(e,'descend');
        v = v(:,i);
        D = min(ni-1,d);
        
        % Check for null/negative eigenvalue
        t = find(e<eps);
        if size(t,1)>1
            %D=t(1)-1;
            e(D:end)=0;
        end
        
        sc = abs(diff(e));
        catell(CLASSE) = length(e)-1;
        for j=1:length(e)-1
            if prod(double(sc(j+1:end) < s*max(sc))),
                catell(CLASSE) = j; break;
            end
        end
        
    end
end