function K = compute_kernel_test(X,Y,sig,Dt)
% Compute the RBF kernel matrix
if length(sig)==1
    X = X / sig;
    Y = Y / sig;
else
    sig_b=sig(end);
    sig=sig(1:end-1);
    X = X ./ repmat(sig',size(X,1),1);
    Y = Y ./ repmat(sig',size(Y,1),1);
end;

K = exp(-0.5*(sqdist(X,Y)));
K = K.*exp(-0.5*Dt/(sig_b^2));