function yp = predict_hdda_rbf(xt,x,sig,alpha,b,V)

% Get size of the data
[n,d]=size(x);
nt= size(xt,1);
yp=zeros(length(sig),nt);

% split the testing set
SPLIT = 20000;

for CLASSE=1:length(sig)
    % Project the data
    X=x*V{CLASSE};
    Xt=xt*V{CLASSE};
    
    for s=1:SPLIT:nt
        if(s+SPLIT <nt)
            Dt = sqdist(xt(s:s+SPLIT,:),x);
            K = compute_kernel_test(Xt(s:s+SPLIT,:),X,sig{CLASSE},Dt);
            yp(CLASSE,s:s+SPLIT)=K*alpha{CLASSE} + b{CLASSE};
        else
            Dt = sqdist(xt(s:end,:),x);
            K = compute_kernel_test(Xt(s:end,:),X,sig{CLASSE},Dt);
            yp(CLASSE,s:end)=K*alpha{CLASSE} + b{CLASSE};
        end
    end
    
    
end